#!/bin/sh
#Version 0.0.2
PATH=/usr/bin:/bin:/usr/sbin:/sbin
#echo $1

if tar -tf $1 Firmware >>/$USBPATH/bootlog 2>&1
then
#   echo "Firmware im Archiv vorhanden"
   FEHLER="0"

   # lsche alte Firmware
   cd /firmware
   rm -f Firmware

   # wechsle ins tmp Verzeichnis
   cd /tmp

   # kopiere data ordner, hier gibt tar immer ein Fehler zurck
#   tar -xf $1 --directory=/firmware data/* 2> /dev/null

   # kopiere Bootscript
   tar -xf $1 --directory=/firmware boot.sh #>>/$USBPATH/bootlog 2>&1
   chmod 777 /firmware/boot.sh >>/$USBPATH/bootlog 2>&1

   # kopier neue inittab um Bootscript auszufhren
#   tar -xf $1 --directory=/etc inittab >>/$USBPATH/bootlog 2>&1

   # lsche unntige Dateien und Ordner
#   rm -rf /firmware/data/config/device.dat >>/$USBPATH/bootlog 2>&1
#   rm -rf /firmware/data/devicetyp/756 >>/$USBPATH/bootlog 2>&1			
#   rm -rf /firmware/data/devicetyp/9999 >>/$USBPATH/bootlog 2>&1		
#   rm -rf /firmware/data/statistic/* >>/$USBPATH/bootlog 2>&1
#   chmod 777 /firmware/resources/pics >>/$USBPATH/bootlog 2>&1			# Freigabe normal 755
#   rm -rf /firmware/resources/pics >>/$USBPATH/bootlog 2>&1				# Testpfad fr Style Bilder
#   rm -rf /firmware/pass.jpg >>/$USBPATH/bootlog 2>&1					# alte Icons

   # kopiere Treiber
   rm -rf /firmware/hwd1800.ko >>/$USBPATH/bootlog 2>&1
   tar -xf $1 --directory=/firmware hwd1800.ko >>/$USBPATH/bootlog 2>&1

   # kopiere neues CAN Protokoll (01.10.2012)
#   rm -rf /firmware/CAN >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware CAN >>/$USBPATH/bootlog 2>&1

   # kopiere Gertevarianten
#   tar -xf $1 --directory=/firmware/data/devicetyp 1800 >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware/data/devicetyp 1801 >>/$USBPATH/bootlog 2>&1
   tar -xf $1 --directory=/firmware/data devicetyp >>/$USBPATH/bootlog 2>&1

   # kopiere Gertekonfiguration
   rm -rf /firmware/data/config/config.bak >>/$USBPATH/bootlog 2>&1
   rm -rf /firmware/data/device/device.bak >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware/data/config config.dat >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware/data/device device.dat >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware Init.ini >>/$USBPATH/bootlog 2>&1
   
   # berschreibe den Passwort-Bootlevel
#   sed -i s/PWBootLevel:.*/PWBootLevel:1/ /firmware/data/config/config.dat >>/$USBPATH/bootlog 2>&1

   # kopiere neuen Style (15.06.2012)
#   tar -xf $1 --directory=/firmware/resources pic >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware Logo.tif >>/$USBPATH/bootlog 2>&1
   tar -xf $1 --directory=/firmware/resources/style Style.css >>/$USBPATH/bootlog 2>&1
   tar -xf $1 --directory=/firmware/data/config res_style.xsl >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware/data/config res_style.css >>/$USBPATH/bootlog 2>&1

   # lsche alte Programme und Sprachdateien
#   rm -rf /firmware/resources/samples/* >>/$USBPATH/bootlog 2>&1		#
#   rm -rf /firmware/resources/help/* >>/$USBPATH/bootlog 2>&1			#
#   rm -rf /firmware/resources/usermanual/* >>/$USBPATH/bootlog 2>&1		# immer "not found in archive" Error
#   rm -rf /firmware/data/lang/* >>/$USBPATH/bootlog 2>&1				#
#   rm -rf /firmware/data/programs/* >>/$USBPATH/bootlog 2>&1
   
   # kopiere neues Paket Sprache, Hilfe und Defaultporgramme (27.08.2012)
#   tar -xf $1 --directory=/firmware/resources samples >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware/resources help >>/$USBPATH/bootlog 2>&1
   tar -xf $1 --directory=/firmware/resources usermanual >>/$USBPATH/bootlog 2>&1
   tar -xf $1 --directory=/firmware/data lang >>/$USBPATH/bootlog 2>&1
#   cp /firmware/resources/samples/en/* /firmware/data/programs >>/$USBPATH/bootlog 2>&1
#   rm -rf /firmware/resources/help/de/* >>/$USBPATH/bootlog 2>&1						#
#   tar -xf $1 --directory=/firmware/resources help/de/* >>/$USBPATH/bootlog 2>&1		# nachtrglich aufspielen der deutschen bersetzung
#   tar -xf $1 --directory=/firmware/data/lang firmware_de.qm >>/$USBPATH/bootlog 2>&1	#

   # Hardlinks fr BDA in allen Sprachen
   find /firmware/resources/usermanual/* -type d -exec ln /firmware/resources/usermanual/en/manual.pdf {}/manual.pdf \; >>/$USBPATH/bootlog 2>&1
   
   
   
   # kopiere neuen Tastatur Treiber (01.10.2012)
#   rm -rf /firmware/startcan.sh >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware startcan.sh >>/$USBPATH/bootlog 2>&1
#   rm -rf /firmware/cpu1800-keys.ko >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware cpu1800-keys.ko >>/$USBPATH/bootlog 2>&1

   # kopiere Updatefiles Generator Firmware
#   rm -rf /firmware/data/generator/* >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware/data generator >>/$USBPATH/bootlog 2>&1		#  erstmalig erstellen des Pfads mit Dateien
#   chmod 777 /firmware/data/generator >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware/data/generator/ firmware.cti >>/$USBPATH/bootlog 2>&1
#   tar -xf $1 --directory=/firmware/data/generator/ firmware.hex >>/$USBPATH/bootlog 2>&1

   # berschreibe Passwrter alter Gerte fr neue Firmware
		chmod 777 /firmware/data/config/config.dat >>/$USBPATH/bootlog 2>&1	
		#Service
		sed -i s/PW_Service:.*/PW_Service:ABiCu6Xens4lc/ /firmware/data/config/config.dat >>/$USBPATH/bootlog 2>&1
		#Admin
		sed -i s/PW_Admin:.*/PW_Admin:ABm5KkFtJT7QE/ /firmware/data/config/config.dat >>/$USBPATH/bootlog 2>&1

   # ergnze config.dat um Parameter fr Discharge-Funktion
#		echo DischargeMode:1 >> /firmware/data/config/config.dat >>/$USBPATH/bootlog 2>&1
#		sed -i s/DischargeMode:.*/DischargeMode:1/ /firmware/data/config/config.dat >>/$USBPATH/bootlog 2>&1
	
	# setzte Gertetyp HA1800B
#		chmod 777 /firmware/data/device/device.dat >>/$USBPATH/bootlog 2>&1	
#		sed -i s/INFO_Version_Geraet:.*/INFO_Version_Geraet:1800/ /firmware/data/device/device.dat >>/$USBPATH/bootlog 2>&1

	
   # ndere LC in L1 im Devicetyp
		# sed -i s/LC/L1/ /firmware/data/devicetyp/1800 >>/$USBPATH/bootlog 2>&1
		# sed -i s/LC/L1/ /firmware/data/devicetyp/1801 >>/$USBPATH/bootlog 2>&1

  # kopiere Firmware (01.10.2012)
   tar -xf $1 --directory=/firmware Firmware
else
   echo "Firmware im Archiv nicht vorhanden"
   FEHLER="1"
fi

return $FEHLER

# beenden der Firmware (wird automatisch neu gestartet)
# killall Firmware